package com.ossDemo.callbackListenerSpringBoot.controller;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.RestController;

import com.ossDemo.callbackListenerSpringBoot.model.OssCallbackVo;
import com.ossDemo.callbackListenerSpringBoot.service.OssCallbackService;

@RestController
public class CallbackController {

	@Autowired
	private OssCallbackService ossCallbackService;

	@PostMapping("/callback")
	@ResponseStatus(HttpStatus.OK)
	public void callback(@RequestBody OssCallbackVo ossCallbackVo, @RequestHeader("Authorization") String callbackKey,@RequestHeader Map<String, String> headers) {
		
		  headers.forEach((key, value) -> {
			  System.out.println(String.format("Header '%s' = %s", key, value));
		    });
		System.out.println("receive a callback notification!");
		
		// 1. check callback key
		if (callbackKey != null) {
			System.out.println("callback key: " + callbackKey);
			if (!ossCallbackService.validateCallbackKey(callbackKey)) {
				throw new RuntimeException("Callback key is not valid: " + callbackKey);
			}
		}
		System.out.println("callback body: " + ossCallbackVo);

		// 2. handle callback asynchronously
		try {
			ossCallbackService.handleCallback(ossCallbackVo);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
