package com.ossDemo.callbackListenerSpringBoot.service;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import com.ossDemo.callbackListenerSpringBoot.configuration.OssConfiguration;
import com.ossDemo.callbackListenerSpringBoot.model.OssCallbackEvents;
import com.ossDemo.callbackListenerSpringBoot.model.OssCallbackVo;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.io.Files;

@Service
public class OssCallbackService {

	@Autowired
	private OssConfiguration ossConfiguration;

	public boolean validateCallbackKey(String callbackKey) {
		if (callbackKey != null) {
			String base64Credentials = callbackKey.substring("Basic".length()).trim();
			return ossConfiguration.CALLBACK_KEY.equals(base64Credentials);
		} else {
			return false;
		}
	}

	@Async("asyncExecutor")
	public void handleCallback(OssCallbackVo ossCallbackVo) {
		switch (OssCallbackEvents.valueOf(ossCallbackVo.getName())) {
		case DOCUMENT_SIGNED:

			break;
		case EMAIL_BOUNCE:

			break;
		case KBA_FAILURE:

			break;
		case PACKAGE_ACTIVATE:

			break;
		case PACKAGE_ARCHIVE:

			break;
		case PACKAGE_ATTACHMENT:

			break;
		case PACKAGE_COMPLETE:
			process_PACKAGE_COMPLETE(ossCallbackVo);
			break;
		case PACKAGE_CREATE:

			break;
		case PACKAGE_DEACTIVATE:

			break;
		case PACKAGE_DECLINE:

			break;
		case PACKAGE_DELETE:

			break;
		case PACKAGE_EXPIRE:

			break;
		case PACKAGE_OPT_OUT:

			break;
		case PACKAGE_READY_FOR_COMPLETION:

			break;
		case PACKAGE_RESTORE:

			break;
		case PACKAGE_TRASH:

			break;
		case ROLE_REASSIGN:

			break;
		case SIGNER_COMPLETE:

			break;
		case SIGNER_LOCKED:

			break;
		case TEMPLATE_CREATE:

			break;

		default:
			break;
		}

	}

	private void process_PACKAGE_COMPLETE(OssCallbackVo ossCallbackVo) {
		EslClient eslClient = new EslClient(ossConfiguration.API_KEY, ossConfiguration.API_URL);
		String packageId = ossCallbackVo.getPackageId();
		byte[] documents = eslClient.downloadZippedDocuments(new PackageId(packageId));

		String filePath = ossConfiguration.FILE_SAVE_PATH + "\\documents_" + packageId + "_"
				+ new SimpleDateFormat("yyyy_MM_dd").format(new Date()) + ".zip";

		Files.saveTo(documents, filePath);
	}

	private void process_DOCUMENT_SIGNED(OssCallbackVo ossCallbackVo) {
	}

	private void process_SIGNER_COMPLETE(OssCallbackVo ossCallbackVo) {
	}

	private void process_PACKAGE_TRASH(OssCallbackVo ossCallbackVo) {
	}

	private void process_PACKAGE_READY_FOR_COMPLETION(OssCallbackVo ossCallbackVo) {
	}

}
